%Eden


####################################################################
##
##  EDEN script
##
##  The definitions that are required to make the gameplay by creating
##  the possible moves of each chess pieces
##
####################################################################

/*
 * Down here is just some code to make a list of possible moves by rook, knight, bishop and queen
 * Now only the function of the knightmoves, bishopmoves, rookmoves and queenmoves can select the move that has no pieces on it.
 */
 
func isBorder {
        para n;
	if (n != 0) {
        	return ((n%8) == 0) || ((n%8) == 1);
	} else return 0;
}

func isKnight2BorderRight {
	para n;
	if (n != 0) {
		return ((n%8) == 7) || ((n%8) == 0);
	} else return 0;
}

func isKnight2BorderLeft {
	para n;
	if (n != 0) {
		return ((n%8) == 1) || ((n%8) == 2);
	} else return 0;
}

func isKnightBorderRight {
	para n;
	return ((n%8) == 0);
}

func isKnightBorderLeft {
	para n;
	return ((n%8) == 1);
}

/*
 * Rook possible moves, based on the current chess board, the function will check
 * the column and row that the rook piece is on. It will check that on the row, if
 * on the right hand side of the rook piece, only take blank square after another
 * chess piece. And on the left hand side, stop after see a chess piece.
 */

func rookmoves {
	para ix;
	auto i, j, a, b, result, result1, result2, result3;
	blank = "";
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	result = [];
	result1 = [];
	result2 = [];
	result3 = [];
	i=0;
	while (8*i<ix) i++;
	j=0;
	a = 0;
	b = 0;
	while (j < 8) {
		if (`"piece"//str(ix)` == "R") {
			if (((8*i-j) < ix) && (isinls(`"piece"//str(8*i - j)`,upperlist) == 1)){
				break;
			}
			else {
				result1 = (8*i - j != ix ) ? result1 // [8*i-j] : result1;
				if ((isinls(`"piece"//str(8*i - j)`,upperlist) == 1) && ((8*i-j) > ix)) {
					for (no = 0; no <= j; no++) {
						if (result1 != []) {
							shift result1;
						}
					}
				} 
				if ((isinls(`"piece"//str(8*i - j)`,lowerlist) == 1) && ((8*i-j) > ix)) {
					for (no = 0; no <= j; no++) {
						if (result1 != []) {
							shift result1;
						}
					}
					result1 = (8*i - j != ix ) ? result1 // [8*i-j] : result1;
				}
				j++;
			}
		} else {
			if ((isinls(`"piece"//str(8*i - j)`,lowerlist) == 1) && ((8*i-j) < ix)) {
				break;
			}
			else {
				result1 = (8*i - j != ix ) ? result1 // [8*i-j] : result1;
				if ((isinls(`"piece"//str(8*i - j)`,lowerlist) == 1) && ((8*i-j) > ix)) {
					for (no = 0; no <= j; no++) {
						if (result1 != []) {
							shift result1;
						}
					}
				}
				if ((isinls(`"piece"//str(8*i - j)`,upperlist) == 1) && ((8*i-j) > ix)) {
					for (no = 0; no <= j; no++) {
						if (result1 != []) {
							shift result1;
						}
					}
					result1 = (8*i - j != ix ) ? result1 // [8*i-j] : result1;
				}
				j++;
			}
		}
	}	
	while (a < 8) {
		if (`"piece"//str(ix)` == "R") {
			if ((isinls(`"piece"//str(ix-8*a)`,upperlist) == 1) && ((ix-8*a) < ix)) {
				break;
			} else {
				if (isinls(`"piece"//str(ix-8*a)`,lowerlist) == 1) {
					result2 = ((ix >= 8*a) && (ix-8*a != ix)) ? result2 // [ix-8*a] : result2;
					break;
				} else {
					result2 = ((ix >= 8*a) && (ix-8*a != ix)) ? result2 // [ix-8*a] : result2;
					a++;
				}
			} 
		} else {
			if ((isinls(`"piece"//str(ix-8*a)`,lowerlist) == 1) && ((ix-8*a) < ix)) {
				break;
			} else {
				if (isinls(`"piece"//str(ix-8*a)`,upperlist) == 1) {
					result2 = ((ix >= 8*a) && (ix-8*a != ix)) ? result2 // [ix-8*a] : result2;
					break;
				} else {
					result2 = ((ix >= 8*a) && (ix-8*a != ix)) ? result2 // [ix-8*a] : result2;
					a++;
				}
			}
		}
	}
	while (b < 8) {
		if (`"piece"//str(ix)` == "R") {
			result3 = ((ix <= 8*b) && (ix-8*b != ix)) ? result3 // [ix+8*(8-b)] : result3;
			if ((isinls(`"piece"//str(ix+8*(8-b))`,upperlist) == 1) && ((ix+8*(8-b)) > ix)) {
				for (no1 = 0; no1 <= b; no1++) {
					if (result3 != []) {
						shift result3;
						}
					}
			}
			if ((isinls(`"piece"//str(ix+8*(8-b))`,lowerlist) == 1) && ((ix+8*(8-b)) > ix)) {
				for (no1 = 0; no1 <= b; no1++) {
					if (result3 != []) {
						shift result3;
					}
				}
				result3 = ((ix <= 8*b) && (ix-8*b != ix)) ? result3 // [ix+8*(8-b)] : result3;
			}
			b++;
		} else {
			result3 = ((ix <= 8*b) && (ix-8*b != ix)) ? result3 // [ix+8*(8-b)] : result3;
			if ((isinls(`"piece"//str(ix+8*(8-b))`,lowerlist) == 1) && ((ix+8*(8-b)) > ix)) {
				for (no1 = 0; no1 <= b; no1++) {
					if (result3 != []) {
						shift result3;
					}
				}
			}
			if ((isinls(`"piece"//str(ix+8*(8-b))`,upperlist) == 1) && ((ix+8*(8-b)) > ix)) {
				for (no1 = 0; no1 <= b; no1++) {
					if (result3 != []) {
						shift result3;
					}
				}
				result3 = ((ix <= 8*b) && (ix-8*b != ix)) ? result3 // [ix+8*(8-b)] : result3;
			}
			b++;
		}
	}
	while (result1 != []) {
		result = result // [result1[1]];
		shift result1;
	}
	while (result2 != []) {
		result = result // [result2[1]];
		shift result2;
	}
	while (result3 != []) {
		result = result // [result3[1]];
		shift result3;
	}
	return result;
}

/*
 * Bishop possible moves. Check all the diagnose, top left, top right, bottom left, bottom right.
 * Stop when see any chess pieces on the way of 4 directions.
 */
func bishopmoves {
	para ix;
	auto i, j, a, b, c, d, e, f, result;
	blank = "";
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	result = [];
	i = 0;
	j = 0;
	a = 0;
	b = 1;
	c = 0;
	d = 1;
	e = 0;
	f = 0;
	while ((i < 8) && (isKnightBorderLeft(j) == 0)) {
		if (`"piece"//str(ix)` == "B"){
			if ((isinls(`"piece"//str(ix-9*i)`, upperlist) == 1) && (i != 0)) {
				break;
			} 
			if ((isinls(`"piece"//str(ix-9*i)`, lowerlist) == 1) && (i != 0)) {
				result = (ix-9*i != ix) && (ix - 9*i > 0) ? result // [ix-9*i] : result;
				break;
			} else {
				result = (ix-9*i != ix) && (ix - 9*i > 0) ? result // [ix-9*i] : result;
				if (ix - 9*i >0) {
					j = ix-9*i;
				}
				i++;
			}
		} else {
			if ((isinls(`"piece"//str(ix-9*i)`, lowerlist) == 1) && (i != 0)) {
				break;
			} 
			if ((isinls(`"piece"//str(ix-9*i)`, upperlist) == 1) && (i != 0)) {
				result = (ix-9*i != ix) && (ix - 9*i > 0) ? result // [ix-9*i] : result;
				break;
			} else {
				result = (ix-9*i != ix) && (ix - 9*i > 0) ? result // [ix-9*i] : result;
				if (ix - 9*i >0) {
					j = ix-9*i;
				}
				i++;
			}
		}
	}
	while ((a < 8) && (isKnightBorderRight(b) == 0)) {
		if (`"piece"//str(ix)` == "B"){
			if ((isinls(`"piece"//str(ix+9*a)`, upperlist) == 1) && (a != 0)) {
				break;
			}
			if ((isinls(`"piece"//str(ix+9*a)`, lowerlist) == 1) && (a != 0)) {
				result = (ix+9*a != ix) && (ix+9*a < 65)  ? result // [ix+9*a] : result;
				break;
			} else {
				result = (ix+9*a != ix) && (ix+9*a < 65)  ? result // [ix+9*a] : result;
				if (ix + 9*a < 65) {
					b = ix + 9*a;
				}
				a++;
			}
		} else {
			if ((isinls(`"piece"//str(ix+9*a)`, lowerlist) == 1) && (a != 0)) {
				break;
			}
			if ((isinls(`"piece"//str(ix+9*a)`, upperlist) == 1) && (a != 0)) {
				result = (ix+9*a != ix) && (ix+9*a < 65)  ? result // [ix+9*a] : result;
				break;
			} else {
				result = (ix+9*a != ix) && (ix+9*a < 65)  ? result // [ix+9*a] : result;
				if (ix + 9*a < 65) {
					b = ix + 9*a;
				}
				a++;
			}
		}
	}
	while ((c < 8) && (isKnightBorderRight(d) == 0)) {
		if (`"piece"//str(ix)` == "B") {
			if ((isinls(`"piece"//str(ix-7*c)`, upperlist) == 1) && (c != 0)) {
				break;
			}
			if ((isinls(`"piece"//str(ix-7*c)`, lowerlist) == 1) && (c != 0)) {
				result = (ix-7*c != ix) && (ix - 7*c > 0) ? result // [ix-7*c] : result;
				break;
			} else {
				result = (ix-7*c != ix) && (ix - 7*c > 0) ? result // [ix-7*c] : result;
				if (ix - 7*c >0) {
					d = ix-7*c;
				}
				c++;
			}
		} else {
			if ((isinls(`"piece"//str(ix-7*c)`, lowerlist) == 1) && (c != 0)) {
				break;
			}
			if ((isinls(`"piece"//str(ix-7*c)`, upperlist) == 1) && (c != 0)) {
				result = (ix-7*c != ix) && (ix - 7*c > 0) ? result // [ix-7*c] : result;
				break;
			} else {
				result = (ix-7*c != ix) && (ix - 7*c > 0) ? result // [ix-7*c] : result;
				if (ix - 7*c >0) {
					d = ix-7*c;
				}
				c++;
			}
		}
	}
	while ((e < 8) && (isKnightBorderLeft(f) == 0)) {
		if (`"piece"//str(ix)` == "B") {
			if ((isinls(`"piece"//str(ix+7*e)`, upperlist) == 1) && (e != 0)) {
				break;
			}
			if ((isinls(`"piece"//str(ix+7*e)`, lowerlist) == 1) && (e != 0)) {
				result = (ix+7*e != ix) && (ix+7*e < 65)  ? result // [ix+7*e] : result;
				break;
			} else {
				result = (ix+7*e != ix) && (ix+7*e < 65)  ? result // [ix+7*e] : result;
				if (ix + 7*e < 65) {
					f = ix + 7*e;
				}
				e++;
			}
		} else {
			if ((isinls(`"piece"//str(ix+7*e)`, lowerlist) == 1) && (e != 0)) {
				break;
			}
			if ((isinls(`"piece"//str(ix+7*e)`, upperlist) == 1) && (e != 0)) {
				result = (ix+7*e != ix) && (ix+7*e < 65)  ? result // [ix+7*e] : result;
				break;
			} else {
				result = (ix+7*e != ix) && (ix+7*e < 65)  ? result // [ix+7*e] : result;
				if (ix + 7*e < 65) {
					f = ix + 7*e;
				}
				e++;
			}
		}
	}
	return result;
}

/*
 * Possible knight moves. Check all the possible squares of a knight, but do not accept the square
 * that contain any chess pieces.
 */

func knightmoves {
	para ix;
	auto i, j, result;
	blank = "";
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	result = [];
	if (`"piece"//str(ix)` == "N"){
		result = (ix + 10 < 64) && (isKnight2BorderRight(ix) == 0) && ((`"piece"//str(ix + 10)` == blank) || (isinls(`"piece"//str(ix + 10)`, lowerlist) == 1)) ? result // [ix + 10] : result;
		result = (ix - 10 > 0) && (isKnight2BorderLeft(ix) == 0) && ((`"piece"//str(ix - 10)` == blank) || (isinls(`"piece"//str(ix - 10)`, lowerlist) == 1)) ? result // [ix - 10] : result;
		result = (ix + 6 < 64) && (isKnight2BorderLeft(ix) == 0) && ((`"piece"//str(ix + 6)` == blank) || (isinls(`"piece"//str(ix + 6)`, lowerlist) == 1)) ? result // [ix + 6] : result;
		result = (ix - 6 > 0) && (isKnight2BorderRight(ix) == 0) && ((`"piece"//str(ix - 6)` == blank) || (isinls(`"piece"//str(ix - 6)`, lowerlist) == 1)) ? result // [ix - 6] : result;
		result = (ix + 15 < 64) && (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix + 15)` == blank) || (isinls(`"piece"//str(ix + 15)`, lowerlist) == 1)) ? result // [ix + 15] : result;
		result = (ix - 15 > 0) && (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix - 15)` == blank) || (isinls(`"piece"//str(ix - 15)`, lowerlist) == 1)) ? result // [ix - 15] : result;
		result = (ix + 17 < 64) && (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix + 17)` == blank) || (isinls(`"piece"//str(ix + 17)`, lowerlist) == 1)) ? result // [ix + 17] : result;
		result = (ix - 17 > 0) && (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix - 17)` == blank) || (isinls(`"piece"//str(ix - 17)`, lowerlist) == 1)) ? result // [ix - 17] : result;
	} else {
		result = (ix + 10 < 64) && (isKnight2BorderRight(ix) == 0) && ((`"piece"//str(ix + 10)` == blank) || (isinls(`"piece"//str(ix + 10)`, upperlist) == 1)) ? result // [ix + 10] : result;
		result = (ix - 10 > 0) && (isKnight2BorderLeft(ix) == 0) && ((`"piece"//str(ix - 10)` == blank) || (isinls(`"piece"//str(ix - 10)`, upperlist) == 1)) ? result // [ix - 10] : result;
		result = (ix + 6 < 64) && (isKnight2BorderLeft(ix) == 0) && ((`"piece"//str(ix + 6)` == blank) || (isinls(`"piece"//str(ix + 6)`, upperlist) == 1)) ? result // [ix + 6] : result;
		result = (ix - 6 > 0) && (isKnight2BorderRight(ix) == 0) && ((`"piece"//str(ix - 6)` == blank) || (isinls(`"piece"//str(ix - 6)`, upperlist) == 1)) ? result // [ix - 6] : result;
		result = (ix + 15 < 64) && (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix + 15)` == blank) || (isinls(`"piece"//str(ix + 15)`, upperlist) == 1)) ? result // [ix + 15] : result;
		result = (ix - 15 > 0) && (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix - 15)` == blank) || (isinls(`"piece"//str(ix - 15)`, upperlist) == 1)) ? result // [ix - 15] : result;
		result = (ix + 17 < 64) && (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix + 17)` == blank) || (isinls(`"piece"//str(ix + 17)`, upperlist) == 1)) ? result // [ix + 17] : result;
		result = (ix - 17 > 0) && (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix - 17)` == blank) || (isinls(`"piece"//str(ix - 17)`, upperlist) == 1)) ? result // [ix - 17] : result;
	}
	return result;
}

/*
 * Possible king moves. Somehow similar with the knight move, but the range is different, change to king
 * surrounded area. Castling is enable
 */

func kingmoves {
	para ix;
	auto result;
	blank = "";
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	result = [];
	if (`"piece"//str(ix)` == "K") {
		result = (ix + 8 <= 64) && ((`"piece"//str(ix + 8)` == blank) || (isinls(`"piece"//str(ix + 8)`, lowerlist) == 1)) ? result // [ix + 8] : result;
		result = (ix - 8 > 0) && ((`"piece"//str(ix - 8)` == blank) || (isinls(`"piece"//str(ix - 8)`, lowerlist) == 1)) ? result // [ix - 8] : result;
		result = (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix + 1)` == blank) || (isinls(`"piece"//str(ix + 1)`, lowerlist) == 1)) ? result // [ix + 1] : result;
		result = (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix - 1)` == blank) || (isinls(`"piece"//str(ix - 1)`, lowerlist) == 1)) ? result // [ix - 1] : result;
		result = (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix + 7)` == blank) || (isinls(`"piece"//str(ix + 7)`, lowerlist) == 1)) ? result // [ix + 7] : result;
		result = (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix - 9)` == blank) || (isinls(`"piece"//str(ix - 9)`, lowerlist) == 1)) ? result // [ix - 9] : result;
		result = (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix + 9)` == blank) || (isinls(`"piece"//str(ix + 9)`, lowerlist) == 1)) ? result // [ix + 9] : result;
		result = (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix - 7)` == blank) || (isinls(`"piece"//str(ix - 7)`, lowerlist) == 1)) ? result // [ix - 7] : result;
		result = (iscastlingblack1() == 1) ? result // [3] : result;
		result = (iscastlingblack2() == 1) ? result // [7] : result;
	} else {
		result = (ix + 8 <= 64) && ((`"piece"//str(ix + 8)` == blank) || (isinls(`"piece"//str(ix + 8)`, upperlist) == 1)) ? result // [ix + 8] : result;
		result = (ix - 8 > 0) && ((`"piece"//str(ix - 8)` == blank) || (isinls(`"piece"//str(ix - 8)`, upperlist) == 1)) ? result // [ix - 8] : result;
		result = (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix + 1)` == blank) || (isinls(`"piece"//str(ix + 1)`, upperlist) == 1)) ? result // [ix + 1] : result;
		result = (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix - 1)` == blank) || (isinls(`"piece"//str(ix - 1)`, upperlist) == 1)) ? result // [ix - 1] : result;
		result = (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix + 7)` == blank) || (isinls(`"piece"//str(ix + 7)`, upperlist) == 1)) ? result // [ix + 7] : result;
		result = (isKnightBorderLeft(ix) == 0) && ((`"piece"//str(ix - 9)` == blank) || (isinls(`"piece"//str(ix - 9)`, upperlist) == 1)) ? result // [ix - 9] : result;
		result = (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix + 9)` == blank) || (isinls(`"piece"//str(ix + 9)`, upperlist) == 1)) ? result // [ix + 9] : result;
		result = (isKnightBorderRight(ix) == 0) && ((`"piece"//str(ix - 7)` == blank) || (isinls(`"piece"//str(ix - 7)`, upperlist) == 1)) ? result // [ix - 7] : result;
		result = (iscastlingwhite1() == 1) ? result // [59] : result;
		result = (iscastlingwhite2() == 1) ? result // [63] : result;
	}
	return result;
}

/*
 * Possible queen moves. This function is the combination between rookmoves and bishopmoves function
 */

func queenmoves {
	para ix;
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	result = [];
	result1 = [];
	result2 = [];
	if (`"piece"//str(ix)` == "Q") {
		`"piece"//str(ix)` = "R";
		result1 = rookmoves(ix);
		`"piece"//str(ix)` = "B";
		result2 = bishopmoves(ix);
		`"piece"//str(ix)` = "Q";
	} 
	if (`"piece"//str(ix)` == "q") {
		`"piece"//str(ix)` = "r";
		result1 = rookmoves(ix);
		`"piece"//str(ix)` = "b";
		result2 = bishopmoves(ix);
		`"piece"//str(ix)` = "q";
	}
	while (result1 != []) {
		result = result // [result1[1]];
		shift result1;
	}
	while (result2 != []) {
		result = result // [result2[1]];
		shift result2;
	}
	return result;
}

/*
 * Possible moves of the pawn. Check whether the chess piece can move up or eat one another chess piece
 * Take into account if you have already moved or not, so the chess piece can move 2 step up.
 * En parser capture is enable.
 */
func pawnmoves {
	para ix;
	auto result;
	result = [];
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	blank = "";
	if ((`"piece"//str(ix)` == "P")){
		result = (ix + 8 <= 64) && (`"piece"//str(ix + 8)` == blank) ? result // [ix + 8] : result;
		result = (ix + 16 <= 32) && (`"piece"//str(ix + 8)` == blank) && (`"piece"//str(ix + 16)` == blank) ? result // [ix + 16] : result;
		result = (ix + 7 <= 64) && (isKnightBorderLeft(ix) == 0) && (isinls(`"piece"//str(ix + 7)`, lowerlist) == 1) ? result // [ix + 7] : result;
		result = (ix + 9 <= 64) && (isKnightBorderRight(ix) == 0) && (isinls(`"piece"//str(ix + 9)`, lowerlist) == 1) ? result // [ix + 9] : result;
		result = (ix + 17 == lastmove) && (lastpiece == "p") && (isKnightBorderRight(ix) == 0) ? result // [ix + 9] : result;
		result = (ix + 15 == lastmove) && (lastpiece == "p") && (isKnightBorderLeft(ix) == 0) ? result // [ix + 7] : result;
	} else {
		result = (ix - 8 > 0) && (`"piece"//str(ix - 8)` == blank) ? result // [ix - 8] : result;
		result = (ix - 16 >= 33) && (`"piece"//str(ix - 8)` == blank) && (`"piece"//str(ix - 16)` == blank) ? result // [ix - 16] : result;
		result = (ix - 7 > 0) && (isKnightBorderRight(ix) == 0) && (isinls(`"piece"//str(ix - 7)`, upperlist) == 1) ? result // [ix - 7] : result;
		result = (ix - 9 > 0) && (isKnightBorderLeft(ix) == 0) && (isinls(`"piece"//str(ix - 9)`, upperlist) == 1) ? result // [ix - 9] : result;
		result = (ix - 15 == lastmove) && (lastpiece == "P") && (isKnightBorderRight(ix) == 0) ? result // [ix - 7] : result;
		result = (ix - 17 == lastmove) && (lastpiece == "P") && (isKnightBorderLeft(ix) == 0) ? result // [ix - 9] : result;
	}
	return result;
	
}
