%eden

####################################################################
##
##  EDEN script
##
##  The definitions that are required to create all procedures
##
####################################################################

/*
 * The procedure which reset the game into the initial states 
 * This procedure just reset all the variables to make new game
 */
proc newgame : resetgame_mouse_1 {
	winner = "Game in progress";
	movelist = [movelist[1]];
	count1 = 0;
	count2 = 0;
	count3 = 0;
	count4 = 0;
	count5 = 0;
	count6 = 0;
	castling1 = 0;
	castling2 = 0;
	castling3 = 0;
	castling4 = 0;
	moveNumber = 0;
	lastpiece = "";
	thismoveboard = "";
	lastmoveboard = "";
	checked = "";
	lastmove = 0;
	thismove = 0;
	toplay = "Black";
	piece1 = "R";
	piece2 = "N";
	piece3 = "B";
	piece4 = "Q";
	piece5 = "K";
	piece6 = "B";
	piece7 = "N";
	piece8 = "R";
	piece9 = "P";
	piece10 = "P";
	piece11 = "P";
	piece12 = "P";
	piece13 = "P";
	piece14 = "P";
	piece15 = "P";
	piece16 = "P";
	piece17 = "";
	piece18 = "";
	piece19 = "";
	piece20 = "";
	piece21 = "";
	piece22 = "";
	piece23 = "";
	piece24 = "";
	piece25 = "";
	piece26 = "";
	piece27 = "";
	piece28 = "";
	piece29 = "";
	piece30 = "";
	piece31 = "";
	piece32 = "";
	piece33 = "";
	piece34 = "";
	piece35 = "";
	piece36 = "";
	piece37 = "";
	piece38 = "";
	piece39 = "";
	piece40 = "";
	piece41 = "";
	piece42 = "";
	piece43 = "";
	piece44 = "";
	piece45 = "";
	piece46 = "";
	piece47 = "";	
	piece48 = "";
	piece49 = "p";
	piece50 = "p";
	piece51 = "p";
	piece52 = "p";
	piece53 = "p";
	piece54 = "p";
	piece55 = "p";
	piece56 = "p";
	piece57 = "r";
	piece58 = "n";
	piece59 = "b";
	piece60 = "q";
	piece61 = "k";
	piece62 = "b";
	piece63 = "n";
	piece64 = "r";
	
	_L1 = label("R", cart (500,500));
	_L2 = label("N", cart (500,500));
	_L3 = label("B", cart (500,500));
	_L4 = label("Q", cart (500,500));

	_L5 = label("K", cart (500,500));
	_L6 = label("B", cart (500,500));
	_L7 = label("N", cart (500,500));
	_L8 = label("R", cart (500,500));
	_L9 = label("P", cart (500,500));
	_L10 = label("P", cart (500,500));
	_L11 = label("P", cart (500,500));
	_L12 = label("P", cart (500,500));
	_L13 = label("P", cart (500,500));
	_L14 = label("P", cart (500,500));
	_L15 = label("P", cart (500,500));
	_L16 = label("P", cart (500,500));
	_L49 = label("p", cart (500,500));
	_L50 = label("p", cart (500,500));
	_L51 = label("p", cart (500,500));
	_L52 = label("p", cart (500,500));
	_L53 = label("p", cart (500,500));
	_L54 = label("p", cart (500,500));
	_L55 = label("p", cart (500,500));
	_L56 = label("p", cart (500,500));
	_L57 = label("r", cart (500,500));
	_L58 = label("n", cart (500,500));
	_L59 = label("b", cart (500,500));
	_L60 = label("q", cart (500,500));
	_L61 = label("k", cart (500,500));
	_L62 = label("b", cart (500,500));
	_L63 = label("n", cart (500,500));
	_L64 = label("r", cart (500,500));

	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	for (i = 1; i <= 64; i++) {
		if (isinls(`"piece"//str(i)`,upperlist) == 1) {
			execute("A_L" // str(i) // " = \"color=red, font={courier 25}\";");
		} else {
			execute("A_L" // str(i) // " = \"color=purple, font={courier 25}\";");
		}
	}
	
	writeln("########");
	writeln("");
	writeln(piece57, piece58, piece59, piece60, piece61, piece62, piece63, piece64);
	writeln(piece49, piece50, piece51, piece52, piece53, piece54, piece55, piece56);
	writeln(piece41, piece42, piece43, piece44, piece45, piece46, piece47, piece48);
	writeln(piece33, piece34, piece35, piece36, piece37, piece38, piece39, piece40);
	writeln(piece25, piece26, piece27, piece28, piece29, piece30, piece31, piece32);
	writeln(piece17, piece18, piece19, piece20, piece21, piece22, piece23, piece24);
	writeln(piece9, piece10, piece11, piece12, piece13, piece14, piece15, piece16);
	writeln(piece1, piece2, piece3, piece4, piece5, piece6, piece7, piece8);
	writeln("");
	writeln("########");
	
}

/*
 * The procedure which change the move number from the chess board into chess move
 *
 */
proc changemovenumber : lastmove{
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	if (lastmove != 0) {
		thismoveboard = ChessNumber[int(thismove)];
		lastmoveboard = ChessNumber[int(lastmove)];
	} 
	for (i = 1; i <= 64; i++) {
		if (isinls(`"piece"//str(i)`,upperlist) == 1) {
			execute("A_L" // str(i) // " = \"color=red, font={courier 25}\";");
		} else {
			execute("A_L" // str(i) // " = \"color=purple, font={courier 25}\";");
		}
	}
}

/*
 * This procedure is used to activate the function "undo" when the user clicks into the "Undo a move" button. 
 */

proc activateundo : undomove_mouse_1{
	if (undomove_mouse_1[1] == 1 ) {
		undo();
	}
}

pieceSelected = "";
pieceDecided = "";


/*
 * The procedure to enable the clicking of the square, left click means select
 * and right click means activate function makemove.
 */
proc square11_makemove: square11_mouse {
	if (square11_mouse[1] == 1 ) {
		pieceSelected = "1";
	}
	if (square11_mouse[1] == 3) {
		pieceDecided = "1";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square12_makemove: square12_mouse {
	if (square12_mouse[1] == 1 ) {
		pieceSelected = "9";
	}
	if (square12_mouse[1] == 3) {
		pieceDecided = "9";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square13_makemove: square13_mouse {
	if (square13_mouse[1] == 1 ) {
		pieceSelected = "17";
	}
	if (square13_mouse[1] == 3) {
		pieceDecided = "17";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square14_makemove: square14_mouse {
	if (square14_mouse[1] == 1 ) {
		pieceSelected = "25";
	}
	if (square14_mouse[1] == 3) {
		pieceDecided = "25";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square15_makemove: square15_mouse {
	if (square15_mouse[1] == 1 ) {
		pieceSelected = "33";
	}
	if (square15_mouse[1] == 3) {
		pieceDecided = "33";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square16_makemove: square16_mouse {
	if (square16_mouse[1] == 1 ) {
		pieceSelected = "41";
	}
	if (square16_mouse[1] == 3) {
		pieceDecided = "41";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square17_makemove: square17_mouse {
	if (square17_mouse[1] == 1 ) {
		pieceSelected = "49";
	}
	if (square17_mouse[1] == 3) {
		pieceDecided = "49";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square18_makemove: square18_mouse {
	if (square18_mouse[1] == 1 ) {
		pieceSelected = "57";
	}
	if (square18_mouse[1] == 3) {
		pieceDecided = "57";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square21_makemove: square21_mouse {
	if (square21_mouse[1] == 1 ) {
		pieceSelected = "2";
	}
	if (square21_mouse[1] == 3) {
		pieceDecided = "2";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square22_makemove: square22_mouse {
	if (square22_mouse[1] == 1 ) {
		pieceSelected = "10";
	}
	if (square22_mouse[1] == 3) {
		pieceDecided = "10";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square23_makemove: square23_mouse {
	if (square23_mouse[1] == 1 ) {
		pieceSelected = "18";
	}
	if (square23_mouse[1] == 3) {
		pieceDecided = "18";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square24_makemove: square24_mouse {
	if (square24_mouse[1] == 1 ) {
		pieceSelected = "26";
	}
	if (square24_mouse[1] == 3) {
		pieceDecided = "26";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square25_makemove: square25_mouse {
	if (square25_mouse[1] == 1 ) {
		pieceSelected = "34";
	}
	if (square25_mouse[1] == 3) {
		pieceDecided = "34";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square26_makemove: square26_mouse {
	if (square26_mouse[1] == 1 ) {
		pieceSelected = "42";
	}
	if (square26_mouse[1] == 3) {
		pieceDecided = "42";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square27_makemove: square27_mouse {
	if (square27_mouse[1] == 1 ) {
		pieceSelected = "50";
	}
	if (square27_mouse[1] == 3) {
		pieceDecided = "50";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square28_makemove: square28_mouse {
	if (square28_mouse[1] == 1 ) {
		pieceSelected = "58";
	}
	if (square28_mouse[1] == 3) {
		pieceDecided = "58";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square31_makemove: square31_mouse {
	if (square31_mouse[1] == 1 ) {
		pieceSelected = "3";
	}
	if (square31_mouse[1] == 3) {
		pieceDecided = "3";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square32_makemove: square32_mouse {
	if (square32_mouse[1] == 1 ) {
		pieceSelected = "11";
	}
	if (square32_mouse[1] == 3) {
		pieceDecided = "11";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square33_makemove: square33_mouse {
	if (square33_mouse[1] == 1 ) {
		pieceSelected = "19";
	}
	if (square33_mouse[1] == 3) {
		pieceDecided = "19";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square34_makemove: square34_mouse {
	if (square34_mouse[1] == 1 ) {
		pieceSelected = "27";
	}
	if (square34_mouse[1] == 3) {
		pieceDecided = "27";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square35_makemove: square35_mouse {
	if (square35_mouse[1] == 1 ) {
		pieceSelected = "35";
	}
	if (square35_mouse[1] == 3) {
		pieceDecided = "35";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square36_makemove: square36_mouse {
	if (square36_mouse[1] == 1 ) {
		pieceSelected = "43";
	}
	if (square36_mouse[1] == 3) {
		pieceDecided = "43";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square37_makemove: square37_mouse {
	if (square37_mouse[1] == 1 ) {
		pieceSelected = "51";
	}
	if (square37_mouse[1] == 3) {
		pieceDecided = "51";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square38_makemove: square38_mouse {
	if (square38_mouse[1] == 1 ) {
		pieceSelected = "59";
	}
	if (square38_mouse[1] == 3) {
		pieceDecided = "59";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square41_makemove: square41_mouse {
	if (square41_mouse[1] == 1 ) {
		pieceSelected = "4";
	}
	if (square41_mouse[1] == 3) {
		pieceDecided = "4";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square42_makemove: square42_mouse {
	if (square42_mouse[1] == 1 ) {
		pieceSelected = "12";
	}
	if (square42_mouse[1] == 3) {
		pieceDecided = "12";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square43_makemove: square43_mouse {
	if (square43_mouse[1] == 1 ) {
		pieceSelected = "20";
	}
	if (square43_mouse[1] == 3) {
		pieceDecided = "20";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square44_makemove: square44_mouse {
	if (square44_mouse[1] == 1 ) {
		pieceSelected = "28";
	}
	if (square44_mouse[1] == 3) {
		pieceDecided = "28";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square45_makemove: square45_mouse {
	if (square45_mouse[1] == 1 ) {
		pieceSelected = "36";
	}
	if (square45_mouse[1] == 3) {
		pieceDecided = "36";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square46_makemove: square46_mouse {
	if (square46_mouse[1] == 1 ) {
		pieceSelected = "44";
	}
	if (square46_mouse[1] == 3) {
		pieceDecided = "44";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square47_makemove: square47_mouse {
	if (square47_mouse[1] == 1 ) {
		pieceSelected = "52";
	}
	if (square47_mouse[1] == 3) {
		pieceDecided = "52";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square48_makemove: square48_mouse {
	if (square48_mouse[1] == 1 ) {
		pieceSelected = "60";
	}
	if (square48_mouse[1] == 3) {
		pieceDecided = "60";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square51_makemove: square51_mouse {
	if (square51_mouse[1] == 1 ) {
		pieceSelected = "5";
	}
	if (square51_mouse[1] == 3) {
		pieceDecided = "5";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square52_makemove: square52_mouse {
	if (square52_mouse[1] == 1 ) {
		pieceSelected = "13";
	}
	if (square52_mouse[1] == 3) {
		pieceDecided = "13";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square53_makemove: square53_mouse {
	if (square53_mouse[1] == 1 ) {
		pieceSelected = "21";
	}
	if (square53_mouse[1] == 3) {
		pieceDecided = "21";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square54_makemove: square54_mouse {
	if (square54_mouse[1] == 1 ) {
		pieceSelected = "29";
	}
	if (square54_mouse[1] == 3) {
		pieceDecided = "29";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square55_makemove: square55_mouse {
	if (square55_mouse[1] == 1 ) {
		pieceSelected = "37";
	}
	if (square55_mouse[1] == 3) {
		pieceDecided = "37";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square56_makemove: square56_mouse {
	if (square56_mouse[1] == 1 ) {
		pieceSelected = "45";
	}
	if (square56_mouse[1] == 3) {
		pieceDecided = "45";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square57_makemove: square57_mouse {
	if (square57_mouse[1] == 1 ) {
		pieceSelected = "53";
	}
	if (square57_mouse[1] == 3) {
		pieceDecided = "53";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square58_makemove: square58_mouse {
	if (square58_mouse[1] == 1 ) {
		pieceSelected = "61";
	}
	if (square58_mouse[1] == 3) {
		pieceDecided = "61";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square61_makemove: square61_mouse {
	if (square61_mouse[1] == 1 ) {
		pieceSelected = "6";
	}
	if (square61_mouse[1] == 3) {
		pieceDecided = "6";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square62_makemove: square62_mouse {
	if (square62_mouse[1] == 1 ) {
		pieceSelected = "14";
	}
	if (square62_mouse[1] == 3) {
		pieceDecided = "14";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square63_makemove: square63_mouse {
	if (square63_mouse[1] == 1 ) {
		pieceSelected = "22";
	}
	if (square63_mouse[1] == 3) {
		pieceDecided = "22";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square64_makemove: square64_mouse {
	if (square64_mouse[1] == 1 ) {
		pieceSelected = "30";
	}
	if (square64_mouse[1] == 3) {
		pieceDecided = "30";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square65_makemove: square65_mouse {
	if (square65_mouse[1] == 1 ) {
		pieceSelected = "38";
	}
	if (square65_mouse[1] == 3) {
		pieceDecided = "38";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square66_makemove: square66_mouse {
	if (square66_mouse[1] == 1 ) {
		pieceSelected = "46";
	}
	if (square66_mouse[1] == 3) {
		pieceDecided = "46";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square67_makemove: square67_mouse {
	if (square67_mouse[1] == 1 ) {
		pieceSelected = "54";
	}
	if (square67_mouse[1] == 3) {
		pieceDecided = "54";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square68_makemove: square68_mouse {
	if (square68_mouse[1] == 1 ) {
		pieceSelected = "62";
	}
	if (square68_mouse[1] == 3) {
		pieceDecided = "62";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square71_makemove: square71_mouse {
	if (square71_mouse[1] == 1 ) {
		pieceSelected = "7";
	}
	if (square71_mouse[1] == 3) {
		pieceDecided = "7";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square72_makemove: square72_mouse {
	if (square72_mouse[1] == 1 ) {
		pieceSelected = "15";
	}
	if (square72_mouse[1] == 3) {
		pieceDecided = "15";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square73_makemove: square73_mouse {
	if (square73_mouse[1] == 1 ) {
		pieceSelected = "23";
	}
	if (square73_mouse[1] == 3) {
		pieceDecided = "23";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square74_makemove: square74_mouse {
	if (square74_mouse[1] == 1 ) {
		pieceSelected = "31";
	}
	if (square74_mouse[1] == 3) {
		pieceDecided = "31";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square75_makemove: square75_mouse {
	if (square75_mouse[1] == 1 ) {
		pieceSelected = "39";
	}
	if (square75_mouse[1] == 3) {
		pieceDecided = "39";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square76_makemove: square76_mouse {
	if (square76_mouse[1] == 1 ) {
		pieceSelected = "47";
	}
	if (square76_mouse[1] == 3) {
		pieceDecided = "47";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square77_makemove: square77_mouse {
	if (square77_mouse[1] == 1 ) {
		pieceSelected = "55";
	}
	if (square77_mouse[1] == 3) {
		pieceDecided = "55";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square78_makemove: square78_mouse {
	if (square78_mouse[1] == 1 ) {
		pieceSelected = "63";
	}
	if (square78_mouse[1] == 3) {
		pieceDecided = "63";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square81_makemove: square81_mouse {
	if (square81_mouse[1] == 1 ) {
		pieceSelected = "8";
	}
	if (square81_mouse[1] == 3) {
		pieceDecided = "8";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square82_makemove: square82_mouse {
	if (square82_mouse[1] == 1 ) {
		pieceSelected = "16";
	}
	if (square82_mouse[1] == 3) {
		pieceDecided = "16";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square83_makemove: square83_mouse {
	if (square83_mouse[1] == 1 ) {
		pieceSelected = "24";
	}
	if (square83_mouse[1] == 3) {
		pieceDecided = "24";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square84_makemove: square84_mouse {
	if (square84_mouse[1] == 1 ) {
		pieceSelected = "32";
	}
	if (square84_mouse[1] == 3) {
		pieceDecided = "32";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square85_makemove: square85_mouse {
	if (square85_mouse[1] == 1 ) {
		pieceSelected = "40";
	}
	if (square85_mouse[1] == 3) {
		pieceDecided = "40";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square86_makemove: square86_mouse {
	if (square86_mouse[1] == 1 ) {
		pieceSelected = "48";
	}
	if (square86_mouse[1] == 3) {
		pieceDecided = "48";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square87_makemove: square87_mouse {
	if (square87_mouse[1] == 1 ) {
		pieceSelected = "56";
	}
	if (square87_mouse[1] == 3) {
		pieceDecided = "56";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
proc square88_makemove: square88_mouse {
	if (square88_mouse[1] == 1 ) {
		pieceSelected = "64";
	}
	if (square88_mouse[1] == 3) {
		pieceDecided = "64";
		if (pieceSelected != pieceDecided) {
			makemove(pieceSelected, pieceDecided);
		}
	}
}
